///
/// Copyright (c) 2022 Arm Limited
/// SPDX-License-Identifier: MIT
///
/// Permission is hereby granted, free of charge, to any person obtaining a copy
/// of this software and associated documentation files (the "Software"), to deal
/// in the Software without restriction, including without limitation the rights
/// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
/// copies of the Software, and to permit persons to whom the Software is
/// furnished to do so, subject to the following conditions:
///
/// The above copyright notice and this permission notice shall be included in all
/// copies or substantial portions of the Software.
///
/// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
/// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
/// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
/// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
/// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
/// SOFTWARE.
///

.data
.p2align 4
roots:
#include "ntt_dilithium_123_456_78_twiddles.s"
.text

// Barrett multiplication
.macro mulmod dst, src, const, const_twisted
        vmul.s32       \dst,  \src, \const
        vqrdmulh.s32   \src,  \src, \const_twisted
        vmla.s32       \dst,  \src, modulus
.endm

.macro ct_butterfly a, b, root, root_twisted
        mulmod tmp, \b, \root, \root_twisted
        vsub.u32       \b,    \a, tmp
        vadd.u32       \a,    \a, tmp
.endm

.macro qsave loc, a       // slothy:no-unfold
        vstrw.32 \a, [sp, #\loc\()]
.endm
.macro qrestore a, loc    // slothy:no-unfold
        vldrw.32 \a, [sp, #\loc\()]
.endm
.macro restored a, b, loc // slothy:no-unfold
        ldrd \a, \b, [sp, #\loc\()]
.endm
.macro saved loc, a, b    // slothy:no-unfold
        strd \a, \b, [sp, #\loc\()]
.endm
.macro restore a, loc     // slothy:no-unfold
        ldr \a, [sp, #\loc\()]
.endm
.macro save loc, a        // slothy:no-unfold
        str \a, [sp, #\loc\()]
.endm

// Aligns stack =0 mod 16
.macro align_stack_do // slothy:no-unfold
        mov r11, sp
        and r12, r11, #0xC   // 8 of ==8 mod 16, 0 otherwise
        sub sp, sp, r12      // Align stack to 16 byte
        sub sp, sp, #16
        str r12, [sp]
.endm

// Reverts initial stack correction
.macro align_stack_undo // slothy:no-unfold
        ldr r12, [sp]
        add sp, sp, #16
        add sp, sp, r12
.endm

#define STACK_SIZE (5*16+8)    // +8 is for alignment
#define QSTACK4 (0*16)
#define QSTACK5 (1*16)
#define QSTACK6 (2*16)

#define ROOT0_STACK (3*16)
#define ROOT1_STACK (3*16 + 8)
#define ROOT4_STACK (4*16)
#define RPTR_STACK  (4*16 + 8)

.align 4
roots_addr: .word roots
.syntax unified
.type ntt_dilithium_123_456_78_opt_size, %function
.global ntt_dilithium_123_456_78_opt_size
ntt_dilithium_123_456_78_opt_size:

        push {r4-r11,lr}
        // Save MVE vector registers
        vpush {d8-d15}

        align_stack_do
        sub sp, sp, #STACK_SIZE

        modulus .req r12
        r_ptr   .req r11

        .equ modulus_const, -8380417
        movw modulus, #:lower16:modulus_const
        movt modulus, #:upper16:modulus_const
        ldr  r_ptr, roots_addr

        in           .req r0
        in_low       .req in
        in_high      .req r1

        add in_high, in, #(4*128)

        root2    .req r2
        root2_tw .req r3
        root3    .req r4
        root3_tw .req r5
        root5    .req r6
        root5_tw .req r7
        root6    .req r8
        root6_tw .req r9

        data0 .req q0
        data1 .req q1
        data2 .req q2
        data3 .req q3
        data4 .req q1
        data5 .req q2
        data6 .req q3
        data7 .req q4

        tmp .req q7

        /* Layers 1-3 */

        rtmp    .req root6
        rtmp_tw .req root6_tw

        ldrd rtmp, rtmp_tw, [r_ptr], #(7*8)
        saved ROOT0_STACK, rtmp, rtmp_tw
        ldrd rtmp, rtmp_tw, [r_ptr, #(1*8 - 7*8)]
        saved ROOT1_STACK, rtmp, rtmp_tw
        ldrd root2, root2_tw, [r_ptr, #(2*8 - 7*8)]
        ldrd root3, root3_tw, [r_ptr, #(3*8 - 7*8)]
        ldrd rtmp, rtmp_tw, [r_ptr, #(4*8 - 7*8)]
        saved ROOT4_STACK, rtmp, rtmp_tw
        ldrd root5, root5_tw, [r_ptr, #(5*8 - 7*8)]
        ldrd root6, root6_tw, [r_ptr, #(6*8 - 7*8)]
        save RPTR_STACK, r_ptr

        .unreq rtmp
        .unreq rtmp_tw
        rtmp    .req r10
        rtmp_tw .req r11

        mov lr, #8
        .p2align 2
.p2align 2
layer123_loop:
        restored r10, r11, ROOT0_STACK         // ..*..................................................................................
        vldrw.32 q3, [in_high, #384]           // ..........................*..........................................................
        vqrdmulh.s32 q6, q3, r11               // ............................*........................................................
        vldrw.32 q5, [in_low, #128]            // .........*...........................................................................
        vmul.s32 q7, q3, r10                   // ...........................*.........................................................
        vldrw.32 q1, [in_high, #128]           // ..........*..........................................................................
        vqrdmulh.s32 q2, q1, r11               // ............*........................................................................
        vldrw.32 q4, [in_high]                 // .*...................................................................................
        vmul.s32 q1, q1, r10                   // ...........*.........................................................................
        vldrw.32 q3, [in_low]                  // *....................................................................................
        vmla.s32 q1, q2, modulus               // .............*.......................................................................
        vldrw.32 q0, [in_high, #256]           // ..................*..................................................................
        vmla.s32 q7, q6, modulus               // .............................*.......................................................
        vsub.u32 q2, q5, q1                    // ..............*......................................................................
        vqrdmulh.s32 q6, q4, r11               // ....*................................................................................
        vadd.u32 q1, q5, q1                    // ...............*.....................................................................
        vmul.s32 q5, q4, r10                   // ...*.................................................................................
        qsave QSTACK5, q2                      // ................*....................................................................
        vmla.s32 q5, q6, modulus               // .....*...............................................................................
        vldrw.32 q6, [in_low, #384]            // .........................*...........................................................
        vmul.s32 q4, q0, r10                   // ...................*.................................................................
        vadd.u32 q2, q6, q7                    // ...............................*.....................................................
        vqrdmulh.s32 q0, q0, r11               // ....................*................................................................
        restored r11, r10, ROOT1_STACK         // ................................*....................................................
        vmla.s32 q4, q0, modulus               // .....................*...............................................................
        vsub.u32 q0, q3, q5                    // ......*..............................................................................
        qsave QSTACK4, q0                      // ........*............................................................................
        vmul.s32 q0, q2, r11                   // ......................................*..............................................
        vadd.u32 q3, q3, q5                    // .......*.............................................................................
        vqrdmulh.s32 q2, q2, r10               // .......................................*.............................................
        vsub.u32 q5, q6, q7                    // ..............................*......................................................
        vldrw.32 q7, [in_low, #256]            // .................*...................................................................
        vadd.u32 q6, q7, q4                    // .......................*.............................................................
        vmla.s32 q0, q2, modulus               // ........................................*............................................
        vsub.u32 q7, q7, q4                    // ......................*..............................................................
        vmul.s32 q4, q6, r11                   // .................................*...................................................
        qsave QSTACK6, q7                      // ........................*............................................................
        vqrdmulh.s32 q6, q6, r10               // ..................................*..................................................
        vadd.u32 q7, q1, q0                    // ..........................................*..........................................
        vmla.s32 q4, q6, modulus               // ...................................*.................................................
        vsub.u32 q0, q1, q0                    // .........................................*...........................................
        vmul.s32 q1, q0, root3                 // ................................................*....................................
        vsub.u32 q6, q3, q4                    // ....................................*................................................
        vqrdmulh.s32 q0, q0, root3_tw          // .................................................*...................................
        qrestore q2, QSTACK6                   // ...........................................................*.........................
        vmla.s32 q1, q0, modulus               // ..................................................*..................................
        restored r10, r11, ROOT4_STACK         // ............................................................*........................
        vadd.u32 q0, q6, q1                    // ....................................................*................................
        vstrw.u32 q0, [in_low, #256]           // .......................................................*.............................
        vmul.s32 q0, q2, r10                   // .............................................................*.......................
        vsub.u32 q6, q6, q1                    // ...................................................*.................................
        vqrdmulh.s32 q1, q2, r11               // ..............................................................*......................
        vstrw.u32 q6, [in_low, #384]           // ........................................................*............................
        vmla.s32 q0, q1, modulus               // ...............................................................*.....................
        qrestore q6, QSTACK4                   // .........................................................*...........................
        vmul.s32 q1, q7, root2                 // ...........................................*.........................................
        vsub.u32 q2, q6, q0                    // ................................................................*....................
        vqrdmulh.s32 q7, q7, root2_tw          // ............................................*........................................
        vadd.u32 q0, q6, q0                    // .................................................................*...................
        vmla.s32 q1, q7, modulus               // .............................................*.......................................
        vadd.u32 q6, q3, q4                    // .....................................*...............................................
        vmul.s32 q7, q5, r10                   // ..................................................................*..................
        vadd.u32 q3, q6, q1                    // ...............................................*.....................................
        vqrdmulh.s32 q4, q5, r11               // ...................................................................*.................
        vsub.u32 q1, q6, q1                    // ..............................................*......................................
        vmla.s32 q7, q4, modulus               // ....................................................................*................
        qrestore q6, QSTACK5                   // ..........................................................*..........................
        vadd.u32 q4, q6, q7                    // ......................................................................*..............
        vmul.s32 q5, q4, root5                 // .......................................................................*.............
        vsub.u32 q7, q6, q7                    // .....................................................................*...............
        vqrdmulh.s32 q6, q4, root5_tw          // ........................................................................*............
        vstrw.u32 q1, [in_low, #128]           // ......................................................*..............................
        vmla.s32 q5, q6, modulus               // .........................................................................*...........
        vstrw.u32 q3, [in_low] , #16           // .....................................................*...............................
        vqrdmulh.s32 q4, q7, root6_tw          // .............................................................................*.......
        vadd.u32 q1, q0, q5                    // ...........................................................................*.........
        vmul.s32 q3, q7, root6                 // ............................................................................*........
        vstrw.u32 q1, [in_high] , #16          // .................................................................................*...
        vsub.u32 q0, q0, q5                    // ..........................................................................*..........
        vmla.s32 q3, q4, modulus               // ..............................................................................*......
        vstrw.u32 q0, [in_high, #112]          // ..................................................................................*..
        vadd.u32 q1, q2, q3                    // ................................................................................*....
        vstrw.u32 q1, [in_high, #240]          // ...................................................................................*.
        vsub.u32 q0, q2, q3                    // ...............................................................................*.....
        vstrw.u32 q0, [in_high, #368]          // ....................................................................................*
        
        // original source code
        // vldrw.32 data0, [in_low]                 // .........*...........................................................................
        // vldrw.32 data4, [in_high]                // .......*.............................................................................
        // restored rtmp, rtmp_tw, ROOT0_STACK      // *....................................................................................
        // vmul.s32 tmp, data4, rtmp                // ................*....................................................................
        // vqrdmulh.s32 data4, data4, rtmp_tw       // ..............*......................................................................
        // vmla.s32 tmp, data4, modulus             // ..................*..................................................................
        // vsub.u32 data4, data0, tmp               // .........................*...........................................................
        // vadd.u32 data0, data0, tmp               // ............................*........................................................
        // qsave QSTACK4, data4                     // ..........................*..........................................................
        // vldrw.32 data1, [in_low, #128]           // ...*.................................................................................
        // vldrw.32 data5, [in_high, #128]          // .....*...............................................................................
        // vmul.s32 tmp, data5, rtmp                // ........*............................................................................
        // vqrdmulh.s32 data5, data5, rtmp_tw       // ......*..............................................................................
        // vmla.s32 tmp, data5, modulus             // ..........*..........................................................................
        // vsub.u32 data5, data1, tmp               // .............*.......................................................................
        // vadd.u32 data1, data1, tmp               // ...............*.....................................................................
        // qsave QSTACK5, data5                     // .................*...................................................................
        // vldrw.32 data2, [in_low, #256]           // ...............................*.....................................................
        // vldrw.32 data6, [in_high, #256]          // ...........*.........................................................................
        // vmul.s32 tmp, data6, rtmp                // ....................*................................................................
        // vqrdmulh.s32 data6, data6, rtmp_tw       // ......................*..............................................................
        // vmla.s32 tmp, data6, modulus             // ........................*............................................................
        // vsub.u32 data6, data2, tmp               // ..................................*..................................................
        // vadd.u32 data2, data2, tmp               // ................................*....................................................
        // qsave QSTACK6, data6                     // ....................................*................................................
        // vldrw.32 data3, [in_low, #384]           // ...................*.................................................................
        // vldrw.32 data7, [in_high, #384]          // .*...................................................................................
        // vmul.s32 tmp, data7, rtmp                // ....*................................................................................
        // vqrdmulh.s32 data7, data7, rtmp_tw       // ..*..................................................................................
        // vmla.s32 tmp, data7, modulus             // ............*........................................................................
        // vsub.u32 data7, data3, tmp               // ..............................*......................................................
        // vadd.u32 data3, data3, tmp               // .....................*...............................................................
        // restored rtmp, rtmp_tw, ROOT1_STACK      // .......................*.............................................................
        // vmul.s32 tmp, data2, rtmp                // ...................................*.................................................
        // vqrdmulh.s32 data2, data2, rtmp_tw       // .....................................*...............................................
        // vmla.s32 tmp, data2, modulus             // .......................................*.............................................
        // vsub.u32 data2, data0, tmp               // ..........................................*..........................................
        // vadd.u32 data0, data0, tmp               // ............................................................*........................
        // vmul.s32 tmp, data3, rtmp                // ...........................*.........................................................
        // vqrdmulh.s32 data3, data3, rtmp_tw       // .............................*.......................................................
        // vmla.s32 tmp, data3, modulus             // .................................*...................................................
        // vsub.u32 data3, data1, tmp               // ........................................*............................................
        // vadd.u32 data1, data1, tmp               // ......................................*..............................................
        // vmul.s32 tmp, data1, root2               // .......................................................*.............................
        // vqrdmulh.s32 data1, data1, root2_tw      // .........................................................*...........................
        // vmla.s32 tmp, data1, modulus             // ...........................................................*.........................
        // vsub.u32 data1, data0, tmp               // ................................................................*....................
        // vadd.u32 data0, data0, tmp               // ..............................................................*......................
        // vmul.s32 tmp, data3, root3               // .........................................*...........................................
        // vqrdmulh.s32 data3, data3, root3_tw      // ...........................................*.........................................
        // vmla.s32 tmp, data3, modulus             // .............................................*.......................................
        // vsub.u32 data3, data2, tmp               // ..................................................*..................................
        // vadd.u32 data2, data2, tmp               // ...............................................*.....................................
        // vstrw.u32 data0, [in_low] , #16          // .........................................................................*...........
        // vstrw.u32 data1, [in_low, #112]          // .......................................................................*.............
        // vstrw.u32 data2, [in_low, #240]          // ................................................*....................................
        // vstrw.u32 data3, [in_low, #368]          // ....................................................*................................
        // qrestore data4, QSTACK4                  // ......................................................*..............................
        // qrestore data5, QSTACK5                  // ..................................................................*..................
        // qrestore data6, QSTACK6                  // ............................................*........................................
        // restored rtmp, rtmp_tw, ROOT4_STACK      // ..............................................*......................................
        // vmul.s32 tmp, data6, rtmp                // .................................................*...................................
        // vqrdmulh.s32 data6, data6, rtmp_tw       // ...................................................*.................................
        // vmla.s32 tmp, data6, modulus             // .....................................................*...............................
        // vsub.u32 data6, data4, tmp               // ........................................................*............................
        // vadd.u32 data4, data4, tmp               // ..........................................................*..........................
        // vmul.s32 tmp, data7, rtmp                // .............................................................*.......................
        // vqrdmulh.s32 data7, data7, rtmp_tw       // ...............................................................*.....................
        // vmla.s32 tmp, data7, modulus             // .................................................................*...................
        // vsub.u32 data7, data5, tmp               // .....................................................................*...............
        // vadd.u32 data5, data5, tmp               // ...................................................................*.................
        // vmul.s32 tmp, data5, root5               // ....................................................................*................
        // vqrdmulh.s32 data5, data5, root5_tw      // ......................................................................*..............
        // vmla.s32 tmp, data5, modulus             // ........................................................................*............
        // vsub.u32 data5, data4, tmp               // ..............................................................................*......
        // vadd.u32 data4, data4, tmp               // ...........................................................................*.........
        // vmul.s32 tmp, data7, root6               // ............................................................................*........
        // vqrdmulh.s32 data7, data7, root6_tw      // ..........................................................................*..........
        // vmla.s32 tmp, data7, modulus             // ...............................................................................*.....
        // vsub.u32 data7, data6, tmp               // ...................................................................................*.
        // vadd.u32 data6, data6, tmp               // .................................................................................*...
        // vstrw.u32 data4, [in_high] , #16         // .............................................................................*.......
        // vstrw.u32 data5, [in_high, #112]         // ................................................................................*....
        // vstrw.u32 data6, [in_high, #240]         // ..................................................................................*..
        // vstrw.u32 data7, [in_high, #368]         // ....................................................................................*
        
        le lr, layer123_loop

        .unreq in_high
        .unreq in_low

        sub in, in, #(128)
        restore r_ptr, RPTR_STACK

        /* Layers 4,5,6 */

        .unreq rtmp
        .unreq rtmp_tw
        rtmp    .req r3
        rtmp_tw .req r4

        mov lr, #8
        .p2align 2
.p2align 2
layer456_loop:
        ldrd r1, r8, [r_ptr] , #56           // *........................................................................................
        vldrw.32 q2, [in, #96]               // ..................*......................................................................
        vmul.s32 q4, q2, r1                  // ...................*.....................................................................
        vldrw.32 q5, [in, #64]               // ..*......................................................................................
        vqrdmulh.s32 q6, q2, r8              // ....................*....................................................................
        vldrw.32 q1, [in, #32]               // .................*.......................................................................
        vmla.s32 q4, q6, modulus             // .....................*...................................................................
        vldrw.32 q7, [in, #112]              // ..........................*..............................................................
        vqrdmulh.s32 q3, q5, r8              // ....*....................................................................................
        vadd.u32 q6, q1, q4                  // .......................*.................................................................
        vmul.s32 q5, q5, r1                  // ...*.....................................................................................
        vldrw.32 q0, [in]                    // .*.......................................................................................
        vmla.s32 q5, q3, modulus             // .....*...................................................................................
        ldrd r3, r5, [r_ptr, #-48]           // ................................*........................................................
        ldrd r10, r6, [r_ptr, #-16]          // .........................................................................*...............
        vsub.u32 q2, q0, q5                  // ......*..................................................................................
        vqrdmulh.s32 q3, q6, r5              // ..................................*......................................................
        qsave QSTACK4, q2                    // ........*................................................................................
        vqrdmulh.s32 q2, q7, r8              // ............................*............................................................
        ldrd r7, r4, [r_ptr, #-8]            // ...............................................................................*.........
        vmul.s32 q7, q7, r1                  // ...........................*.............................................................
        ldrd r9, r2, [r_ptr, #-40]           // ...........................................*.............................................
        vmla.s32 q7, q2, modulus             // .............................*...........................................................
        vadd.u32 q5, q0, q5                  // .......*.................................................................................
        vldrw.32 q2, [in, #80]               // ..........*..............................................................................
        vqrdmulh.s32 q0, q2, r8              // ............*............................................................................
        vsub.u32 q4, q1, q4                  // ......................*..................................................................
        vmul.s32 q1, q2, r1                  // ...........*.............................................................................
        qsave QSTACK6, q4                    // ........................*................................................................
        vmul.s32 q4, q6, r3                  // .................................*.......................................................
        vldrw.32 q2, [in, #48]               // .........................*...............................................................
        vmla.s32 q1, q0, modulus             // .............*...........................................................................
        vadd.u32 q0, q2, q7                  // ...............................*.........................................................
        vqrdmulh.s32 q6, q0, r5              // .......................................*.................................................
        vsub.u32 q7, q2, q7                  // ..............................*..........................................................
        vldrw.32 q2, [in, #16]               // .........*...............................................................................
        vmla.s32 q4, q3, modulus             // ...................................*.....................................................
        vsub.u32 q3, q2, q1                  // ..............*..........................................................................
        vmul.s32 q0, q0, r3                  // ......................................*..................................................
        vadd.u32 q1, q2, q1                  // ...............*.........................................................................
        qsave QSTACK5, q3                    // ................*........................................................................
        vsub.u32 q3, q5, q4                  // ....................................*....................................................
        vmla.s32 q0, q6, modulus             // ........................................*................................................
        ldrd r8, r5, [r_ptr, #-32]           // .................................................*.......................................
        vadd.u32 q2, q1, q0                  // ..........................................*..............................................
        vmul.s32 q6, q2, r9                  // ............................................*............................................
        vsub.u32 q0, q1, q0                  // .........................................*...............................................
        vqrdmulh.s32 q2, q2, r2              // .............................................*...........................................
        vadd.u32 q4, q5, q4                  // .....................................*...................................................
        vmla.s32 q6, q2, modulus             // ..............................................*..........................................
        qrestore q5, QSTACK6                 // .............................................................*...........................
        vadd.u32 q2, q4, q6                  // ................................................*........................................
        ldrd r9, r1, [r_ptr, #-24]           // ..............................................................*..........................
        vsub.u32 q4, q4, q6                  // ...............................................*.........................................
        vqrdmulh.s32 q1, q0, r5              // ...................................................*.....................................
        vstrw.u32 q2, [in] , #128            // .......................................................*.................................
        vmul.s32 q0, q0, r8                  // ..................................................*......................................
        qrestore q2, QSTACK5                 // ............................................................*............................
        vmla.s32 q0, q1, modulus             // ....................................................*....................................
        vstrw.u32 q4, [in, #-112]            // ........................................................*................................
        vqrdmulh.s32 q4, q7, r1              // .....................................................................*...................
        vadd.u32 q6, q3, q0                  // ......................................................*..................................
        vmul.s32 q1, q7, r9                  // ....................................................................*....................
        qrestore q7, QSTACK4                 // ...........................................................*.............................
        vmla.s32 q1, q4, modulus             // ......................................................................*..................
        vsub.u32 q0, q3, q0                  // .....................................................*...................................
        vmul.s32 q3, q5, r9                  // ...............................................................*.........................
        vstrw.u32 q0, [in, #-80]             // ..........................................................*..............................
        vqrdmulh.s32 q5, q5, r1              // ................................................................*........................
        vadd.u32 q4, q2, q1                  // ........................................................................*................
        vmla.s32 q3, q5, modulus             // .................................................................*.......................
        vsub.u32 q2, q2, q1                  // .......................................................................*.................
        vmul.s32 q1, q2, r7                  // ................................................................................*........
        vadd.u32 q0, q7, q3                  // ...................................................................*.....................
        vqrdmulh.s32 q5, q2, r4              // .................................................................................*.......
        vsub.u32 q2, q7, q3                  // ..................................................................*......................
        vmla.s32 q1, q5, modulus             // ..................................................................................*......
        vstrw.u32 q6, [in, #-96]             // .........................................................*...............................
        vqrdmulh.s32 q7, q4, r6              // ...........................................................................*.............
        vsub.u32 q3, q2, q1                  // ...................................................................................*.....
        vmul.s32 q4, q4, r10                 // ..........................................................................*..............
        vstrw.u32 q3, [in, #-16]             // ........................................................................................*
        vadd.u32 q5, q2, q1                  // ....................................................................................*....
        vmla.s32 q4, q7, modulus             // ............................................................................*............
        vstrw.u32 q5, [in, #-32]             // .......................................................................................*.
        vsub.u32 q7, q0, q4                  // .............................................................................*...........
        vstrw.u32 q7, [in, #-48]             // ......................................................................................*..
        vadd.u32 q2, q0, q4                  // ..............................................................................*..........
        vstrw.u32 q2, [in, #-64]             // .....................................................................................*...
        
        // original source code
        // ldrd rtmp, rtmp_tw, [r_ptr] , #56       // *........................................................................................
        // vldrw.32 data0, [in]                    // ...........*.............................................................................
        // vldrw.32 data4, [in, #64]               // ...*.....................................................................................
        // vmul.s32 tmp, data4, rtmp               // ..........*..............................................................................
        // vqrdmulh.s32 data4, data4, rtmp_tw      // ........*................................................................................
        // vmla.s32 tmp, data4, modulus            // ............*............................................................................
        // vsub.u32 data4, data0, tmp              // ...............*.........................................................................
        // vadd.u32 data0, data0, tmp              // .......................*.................................................................
        // qsave QSTACK4, data4                    // .................*.......................................................................
        // vldrw.32 data1, [in, #16]               // ...................................*.....................................................
        // vldrw.32 data5, [in, #80]               // ........................*................................................................
        // vmul.s32 tmp, data5, rtmp               // ...........................*.............................................................
        // vqrdmulh.s32 data5, data5, rtmp_tw      // .........................*...............................................................
        // vmla.s32 tmp, data5, modulus            // ...............................*.........................................................
        // vsub.u32 data5, data1, tmp              // .....................................*...................................................
        // vadd.u32 data1, data1, tmp              // .......................................*.................................................
        // qsave QSTACK5, data5                    // ........................................*................................................
        // vldrw.32 data2, [in, #32]               // .....*...................................................................................
        // vldrw.32 data6, [in, #96]               // .*.......................................................................................
        // vmul.s32 tmp, data6, rtmp               // ..*......................................................................................
        // vqrdmulh.s32 data6, data6, rtmp_tw      // ....*....................................................................................
        // vmla.s32 tmp, data6, modulus            // ......*..................................................................................
        // vsub.u32 data6, data2, tmp              // ..........................*..............................................................
        // vadd.u32 data2, data2, tmp              // .........*...............................................................................
        // qsave QSTACK6, data6                    // ............................*............................................................
        // vldrw.32 data3, [in, #48]               // ..............................*..........................................................
        // vldrw.32 data7, [in, #112]              // .......*.................................................................................
        // vmul.s32 tmp, data7, rtmp               // ....................*....................................................................
        // vqrdmulh.s32 data7, data7, rtmp_tw      // ..................*......................................................................
        // vmla.s32 tmp, data7, modulus            // ......................*..................................................................
        // vsub.u32 data7, data3, tmp              // ..................................*......................................................
        // vadd.u32 data3, data3, tmp              // ................................*........................................................
        // ldrd rtmp, rtmp_tw, [r_ptr, #-48]       // .............*...........................................................................
        // vmul.s32 tmp, data2, rtmp               // .............................*...........................................................
        // vqrdmulh.s32 data2, data2, rtmp_tw      // ................*........................................................................
        // vmla.s32 tmp, data2, modulus            // ....................................*....................................................
        // vsub.u32 data2, data0, tmp              // .........................................*...............................................
        // vadd.u32 data0, data0, tmp              // ................................................*........................................
        // vmul.s32 tmp, data3, rtmp               // ......................................*..................................................
        // vqrdmulh.s32 data3, data3, rtmp_tw      // .................................*.......................................................
        // vmla.s32 tmp, data3, modulus            // ..........................................*..............................................
        // vsub.u32 data3, data1, tmp              // ..............................................*..........................................
        // vadd.u32 data1, data1, tmp              // ............................................*............................................
        // ldrd rtmp, rtmp_tw, [r_ptr, #-40]       // .....................*...................................................................
        // vmul.s32 tmp, data1, rtmp               // .............................................*...........................................
        // vqrdmulh.s32 data1, data1, rtmp_tw      // ...............................................*.........................................
        // vmla.s32 tmp, data1, modulus            // .................................................*.......................................
        // vsub.u32 data1, data0, tmp              // .....................................................*...................................
        // vadd.u32 data0, data0, tmp              // ...................................................*.....................................
        // ldrd rtmp, rtmp_tw, [r_ptr, #-32]       // ...........................................*.............................................
        // vmul.s32 tmp, data3, rtmp               // ........................................................*................................
        // vqrdmulh.s32 data3, data3, rtmp_tw      // ......................................................*..................................
        // vmla.s32 tmp, data3, modulus            // ..........................................................*..............................
        // vsub.u32 data3, data2, tmp              // .................................................................*.......................
        // vadd.u32 data2, data2, tmp              // .............................................................*...........................
        // vstrw.u32 data0, [in] , #128            // .......................................................*.................................
        // vstrw.u32 data1, [in, #-112]            // ...........................................................*.............................
        // vstrw.u32 data2, [in, #-96]             // .............................................................................*...........
        // vstrw.u32 data3, [in, #-80]             // ...................................................................*.....................
        // qrestore data4, QSTACK4                 // ...............................................................*.........................
        // qrestore data5, QSTACK5                 // .........................................................*...............................
        // qrestore data6, QSTACK6                 // ..................................................*......................................
        // ldrd rtmp, rtmp_tw, [r_ptr, #-24]       // ....................................................*....................................
        // vmul.s32 tmp, data6, rtmp               // ..................................................................*......................
        // vqrdmulh.s32 data6, data6, rtmp_tw      // ....................................................................*....................
        // vmla.s32 tmp, data6, modulus            // ......................................................................*..................
        // vsub.u32 data6, data4, tmp              // ...........................................................................*.............
        // vadd.u32 data4, data4, tmp              // .........................................................................*...............
        // vmul.s32 tmp, data7, rtmp               // ..............................................................*..........................
        // vqrdmulh.s32 data7, data7, rtmp_tw      // ............................................................*............................
        // vmla.s32 tmp, data7, modulus            // ................................................................*........................
        // vsub.u32 data7, data5, tmp              // .......................................................................*.................
        // vadd.u32 data5, data5, tmp              // .....................................................................*...................
        // ldrd rtmp, rtmp_tw, [r_ptr, #-16]       // ..............*..........................................................................
        // vmul.s32 tmp, data5, rtmp               // ................................................................................*........
        // vqrdmulh.s32 data5, data5, rtmp_tw      // ..............................................................................*..........
        // vmla.s32 tmp, data5, modulus            // ...................................................................................*.....
        // vsub.u32 data5, data4, tmp              // .....................................................................................*...
        // vadd.u32 data4, data4, tmp              // .......................................................................................*.
        // ldrd rtmp, rtmp_tw, [r_ptr, #-8]        // ...................*.....................................................................
        // vmul.s32 tmp, data7, rtmp               // ........................................................................*................
        // vqrdmulh.s32 data7, data7, rtmp_tw      // ..........................................................................*..............
        // vmla.s32 tmp, data7, modulus            // ............................................................................*............
        // vsub.u32 data7, data6, tmp              // ...............................................................................*.........
        // vadd.u32 data6, data6, tmp              // ..................................................................................*......
        // vstrw.u32 data4, [in, #-64]             // ........................................................................................*
        // vstrw.u32 data5, [in, #-48]             // ......................................................................................*..
        // vstrw.u32 data6, [in, #-32]             // ....................................................................................*....
        // vstrw.u32 data7, [in, #-16]             // .................................................................................*.......
        
        le lr, layer456_loop

        sub in, in, #(4*256)

        .unreq rtmp
        .unreq rtmp_tw
        .unreq root2
        .unreq root2_tw

        /* Layers 7,8 */

        root0         .req q5
        root0_tw .req q6
        root1         .req q5
        root1_tw .req q6
        root2         .req q5
        root2_tw .req q6

        mov lr, #16
        .p2align 2
        vld40.32 {q0,q1,q2,q3}, [in]          // *.........
        // bubble                             // .........*
        vld41.32 {q0,q1,q2,q3}, [in]          // .*........
        // bubble                             // ......*...
        vld42.32 {q0,q1,q2,q3}, [in]          // ..*.......
        // bubble                             // .......*..
        vld43.32 {q0,q1,q2,q3}, [in]!         // ...*......
        // bubble                             // ........*.
        vldrw.32 q7, [r_ptr, #16]             // ....*.....
        vqrdmulh.s32 q4, q2, q7               // .....*....
        
        // original source code
        // vld40.32 {q0,q1,q2,q3}, [in]       // *.........
        // vld41.32 {q0,q1,q2,q3}, [in]       // ..*.......
        // vld42.32 {q0,q1,q2,q3}, [in]       // ....*.....
        // vld43.32 {q0,q1,q2,q3}, [in]!      // ......*...
        // vldrw.32 q7, [r_ptr, #16]          // ........*.
        // vqrdmulh.s32 q4, q2, q7            // .........*
        // nop                                // ...*......
        // nop                                // .....*....
        // nop                                // .......*..
        // nop                                // .*........
        
        sub lr, lr, #1
.p2align 2
layer78_loop:
        vqrdmulh.s32 q7, q3, q7               // ............*.....................
        vldrw.32 q5, [r_ptr] , #96            // ....*.............................
        vmul.s32 q6, q3, q5                   // ...........*......................
        vldrw.32 q3, [r_ptr, #-32]            // .......................*..........
        vmul.s32 q5, q2, q5                   // ......*...........................
        vldrw.32 q2, [r_ptr, #-16]            // ........................*.........
        vmla.s32 q6, q7, modulus              // .............*....................
        vldrw.32 q7, [r_ptr, #-64]            // ................*.................
        vmla.s32 q5, q4, modulus              // ........*.........................
        vsub.u32 q4, q1, q6                   // ..............*...................
        vmul.s32 q3, q4, q3                   // .........................*........
        vadd.u32 q6, q1, q6                   // ...............*..................
        vqrdmulh.s32 q4, q4, q2               // ..........................*.......
        vsub.u32 q2, q0, q5                   // .........*........................
        vmla.s32 q3, q4, modulus              // ...........................*......
        vldrw.32 q4, [r_ptr, #-48]            // .................*................
        vadd.u32 q1, q2, q3                   // .............................*....
        vstrw.u32 q1, [in, #-32]              // ................................*.
        vsub.u32 q2, q2, q3                   // ............................*.....
        vstrw.u32 q2, [in, #-16]              // .................................*
        vadd.u32 q5, q0, q5                   // ..........*.......................
        vld40.32 {q0,q1,q2,q3}, [in]          // e.................................
        vmul.s32 q7, q6, q7                   // ..................*...............
        vld41.32 {q0,q1,q2,q3}, [in]          // .e................................
        vqrdmulh.s32 q6, q6, q4               // ...................*..............
        vld42.32 {q0,q1,q2,q3}, [in]          // ..e...............................
        vmla.s32 q7, q6, modulus              // ....................*.............
        vld43.32 {q0,q1,q2,q3}, [in]!         // ...e..............................
        vsub.u32 q4, q5, q7                   // .....................*............
        vstrw.u32 q4, [in, #-112]             // ...............................*..
        vadd.u32 q6, q5, q7                   // ......................*...........
        vldrw.32 q7, [r_ptr, #16]             // .....e............................
        vqrdmulh.s32 q4, q2, q7               // .......e..........................
        vstrw.u32 q6, [in, #-128]             // ..............................*...
        
        // original source code
        // vld40.32 {data0,data1,data2,data3}, [in]       // e..............................................
        // vld41.32 {data0,data1,data2,data3}, [in]       // ..e............................................
        // vld42.32 {data0,data1,data2,data3}, [in]       // ....e..........................................
        // vld43.32 {data0,data1,data2,data3}, [in]!      // ......e........................................
        // vldrw.32 root0, [r_ptr] , #96                  // ..............*................................
        // vldrw.32 root0_tw, [r_ptr, #-80]               // ..........e....................................
        // vmul.s32 tmp, data2, root0                     // .................*.............................
        // vqrdmulh.s32 data2, data2, root0_tw            // ...........e...................................
        // vmla.s32 tmp, data2, modulus                   // .....................*.........................
        // vsub.u32 data2, data0, tmp                     // ..........................*....................
        // vadd.u32 data0, data0, tmp                     // .................................*.............
        // vmul.s32 tmp, data3, root0                     // ...............*...............................
        // vqrdmulh.s32 data3, data3, root0_tw            // .............*.................................
        // vmla.s32 tmp, data3, modulus                   // ...................*...........................
        // vsub.u32 data3, data1, tmp                     // ......................*........................
        // vadd.u32 data1, data1, tmp                     // ........................*......................
        // vldrw.32 root1, [r_ptr, #-64]                  // ....................*..........................
        // vldrw.32 root1_tw, [r_ptr, #-48]               // ............................*..................
        // vmul.s32 tmp, data1, root1                     // ...................................*...........
        // vqrdmulh.s32 data1, data1, root1_tw            // .....................................*.........
        // vmla.s32 tmp, data1, modulus                   // .......................................*.......
        // vsub.u32 data1, data0, tmp                     // .........................................*.....
        // vadd.u32 data0, data0, tmp                     // ...........................................*...
        // vldrw.32 root2, [r_ptr, #-32]                  // ................*..............................
        // vldrw.32 root2_tw, [r_ptr, #-16]               // ..................*............................
        // vmul.s32 tmp, data3, root2                     // .......................*.......................
        // vqrdmulh.s32 data3, data3, root2_tw            // .........................*.....................
        // vmla.s32 tmp, data3, modulus                   // ...........................*...................
        // vsub.u32 data3, data2, tmp                     // ...............................*...............
        // vadd.u32 data2, data2, tmp                     // .............................*.................
        // vstrw.u32 data0, [in, #-64]                    // ..............................................*
        // vstrw.u32 data1, [in, #-48]                    // ..........................................*....
        // vstrw.u32 data2, [in, #-32]                    // ..............................*................
        // vstrw.u32 data3, [in, #-16]                    // ................................*..............
        
        le lr, layer78_loop
        vqrdmulh.s32 q5, q3, q7             // *...........................
        vldrw.32 q6, [r_ptr] , #96          // .*..........................
        vmul.s32 q7, q3, q6                 // ..*.........................
        vldrw.32 q3, [r_ptr, #-32]          // ...*........................
        vmla.s32 q7, q5, modulus            // ......*.....................
        vldrw.32 q5, [r_ptr, #-64]          // .......*....................
        vmul.s32 q6, q2, q6                 // ....*.......................
        vldrw.32 q2, [r_ptr, #-48]          // ...............*............
        vmla.s32 q6, q4, modulus            // ........*...................
        vadd.u32 q4, q1, q7                 // ...........*................
        vmul.s32 q5, q4, q5                 // .....................*......
        vsub.u32 q7, q1, q7                 // .........*..................
        vqrdmulh.s32 q1, q4, q2             // ......................*.....
        vsub.u32 q4, q0, q6                 // .............*..............
        vmla.s32 q5, q1, modulus            // .......................*....
        vadd.u32 q2, q0, q6                 // ....................*.......
        vmul.s32 q0, q7, q3                 // ..........*.................
        vldrw.32 q1, [r_ptr, #-16]          // .....*......................
        vqrdmulh.s32 q6, q7, q1             // ............*...............
        vsub.u32 q1, q2, q5                 // ........................*...
        vmla.s32 q0, q6, modulus            // ..............*.............
        vstrw.u32 q1, [in, #-48]            // .........................*..
        vsub.u32 q3, q4, q0                 // ..................*.........
        vstrw.u32 q3, [in, #-16]            // ...................*........
        vadd.u32 q1, q2, q5                 // ..........................*.
        vstrw.u32 q1, [in, #-64]            // ...........................*
        vadd.u32 q1, q4, q0                 // ................*...........
        vstrw.u32 q1, [in, #-32]            // .................*..........
        
        // original source code
        // vqrdmulh.s32 q7, q3, q7          // *...........................
        // vldrw.32 q5, [r_ptr] , #96       // .*..........................
        // vmul.s32 q6, q3, q5              // ..*.........................
        // vldrw.32 q3, [r_ptr, #-32]       // ...*........................
        // vmul.s32 q5, q2, q5              // ......*.....................
        // vldrw.32 q2, [r_ptr, #-16]       // .................*..........
        // vmla.s32 q6, q7, modulus         // ....*.......................
        // vldrw.32 q7, [r_ptr, #-64]       // .....*......................
        // vmla.s32 q5, q4, modulus         // ........*...................
        // vsub.u32 q4, q1, q6              // ...........*................
        // vmul.s32 q3, q4, q3              // ................*...........
        // vadd.u32 q6, q1, q6              // .........*..................
        // vqrdmulh.s32 q4, q4, q2          // ..................*.........
        // vsub.u32 q2, q0, q5              // .............*..............
        // vmla.s32 q3, q4, modulus         // ....................*.......
        // vldrw.32 q4, [r_ptr, #-48]       // .......*....................
        // vadd.u32 q1, q2, q3              // ..........................*.
        // vstrw.u32 q1, [in, #-32]         // ...........................*
        // vsub.u32 q2, q2, q3              // ......................*.....
        // vstrw.u32 q2, [in, #-16]         // .......................*....
        // vadd.u32 q5, q0, q5              // ...............*............
        // vmul.s32 q7, q6, q7              // ..........*.................
        // vqrdmulh.s32 q6, q6, q4          // ............*...............
        // vmla.s32 q7, q6, modulus         // ..............*.............
        // vsub.u32 q4, q5, q7              // ...................*........
        // vstrw.u32 q4, [in, #-48]         // .....................*......
        // vadd.u32 q6, q5, q7              // ........................*...
        // vstrw.u32 q6, [in, #-64]         // .........................*..
        

        add sp, sp, #STACK_SIZE
        align_stack_undo

        // Restore MVE vector registers
        vpop {d8-d15}
        // Restore GPRs
        pop {r4-r11,lr}
        bx lr